=== debian/control ===
Source: linuxcnc-ethercat
Section: unknown
Priority: extra
Maintainer: Bjarne von Horn <vh@igh.de>
Build-Depends: debhelper (>= 8.0.0), libexpat1-dev, linuxcnc-dev | linuxcnc-sim-dev | linuxcnc-uspace-dev | machinekit-dev, etherlabmaster-dev | libethercat-dev, golang-go
Standards-Version: 3.9.3

Package: linuxcnc-ethercat
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, linuxcnc | linuxcnc-sim | linuxcnc-uspace | machinekit, etherlabmaster | ethercat-master
Description: LinuxCNC EtherCAT HAL driver
